import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.ArrayList;

/**
 * Klasse Methodenbox für das Fieberthermometer (Kapitel 1.3 Einstiegsaufgabe)
 * 
 * @author Peter Brichzin
 * @version 1.0
 */
public class Methodenbox 
{
    /** Farbanzeige */
    Rechteck farbanzeige;
    /** Temperaturanzeige */
    Text temperaturanzeige;
    /** Warnanzeige */
    Text warnanzeige;
    /** Anleitungstexte */
    Text anleitungstext1;
    Text anleitungstext2;

    /**
     * 
     * Der Konstruktor meldet den Taktgeber
     * und die Eventlistener bei der Zeichenfläche an.
     *
     * Der Konstruktor legt die benötigten Objekte an und richtet sie ein.     
     */
    Methodenbox ()
    {
        Zeichenfenster.AktionsEmpfängerEintragen(new Zeichenfenster.AktionsEmpfaenger()
            {
                public void Ausführen ()
                {
                    TaktImpulsAusführen();
                }

                public void Taste (char taste)
                {
                    TasteGedrückt(taste);
                }

                public void SonderTaste (int taste)
                {
                    SonderTasteGedrückt(taste);
                }

                public void Geklickt (int x, int y, int anzahl)
                {
                    MausGeklickt(x, y, anzahl);
                }
            });

        farbanzeige = new Rechteck();
        farbanzeige.PositionSetzen(125, 75);
        farbanzeige.GrößeSetzen(50, 50);
        farbanzeige.FarbeSetzen("schwarz");
        
        warnanzeige = new Text("warnanzeige");
        warnanzeige.PositionSetzen(200, 150);
        warnanzeige.TextGrößeSetzen(20);
        warnanzeige.TextSetzen("");

        temperaturanzeige = new Text("temperaturanzeige");
        temperaturanzeige.PositionSetzen(125, 150);
        temperaturanzeige.TextGrößeSetzen(20);
        temperaturanzeige.TextSetzen("Beachte, Tastatursteuerung funktioniert nur, wenn Zeichenfenster aktiv ist.");

        anleitungstext1 = new Text("anleitungstext1");
        anleitungstext1.PositionSetzen(75, 250);
        anleitungstext1.TextSetzen("Mit Taste s Messung starten.");
        anleitungstext2 = new Text("anleitungstext2");
        anleitungstext2.PositionSetzen(75, 270);
        anleitungstext2.TextSetzen("Mit +/- Taste Temperatur erhöhen/erniedrigen.");
        
        

    }
    /**
     * Die eigentliche Aktionsmethode des Zeitgebers.
     * <br>Muss bei Bedarf von einer Unterklasse überschrieben werden. 
     */
    void TaktImpulsAusführen ()
    {
        System.out.println ("Tick");
    }

    /**
     * Zeitgeber starten.
     */
    void Starten ()
    {
        Zeichenfenster.TaktgeberStarten();
    }

    /**
     * Zeitgeber anhalten.
     */
    void Anhalten ()
    {
        Zeichenfenster.TaktgeberStoppen();
    }

    /**
     * Ablaufgeschwindigkeit des Zeitgebers einstellen.
     * 
     * @param dauer: Angabe in Millisekunden
     */
    void TaktdauerSetzen (int dauer)
    {
        Zeichenfenster.TaktdauerSetzen(dauer);
    }

    /**
     * Die eigentliche Aktionsmethode für gedrückte Tasten.
     * <br>Muss bei Bedarf von einer Unterklasse überschrieben werden. 
     * @param taste die gedrückte Taste
     */
    void TasteGedrückt (char taste)
    {
        System. out. println ("Taste: " + taste);
        
    }

    /**
     * Die eigentliche Aktionsmethode für gedrückte Sondertasten.
     * <br>Muss bei Bedarf von einer Unterklasse überschrieben werden. 
     * @param taste KeyCode der gedrückten Taste
     */
    void SonderTasteGedrückt (int taste)
    {
        System. out. println ("Sondertaste: " + taste);
    }

    /**
     * Die eigentliche Aktionsmethode für einen Mausklick.
     * <br>Muss bei Bedarf von einer Unterklasse überschrieben werden. 
     * @param x x-Position des Mausklicks
     * @param y y-Position des Mausklicks
     * @param anzahl Anzahl der aufeinanderfolgenden Mausklicks
     */
    void MausGeklickt (int x, int y, int anzahl)
    {
        System. out. println ("Maus: (" + x + "|" + y + "), " + anzahl + " mal");
    }
    
    /**
     * Methode setzeTemperaturanzeige
     *
     * @param neueTemperatur neue Temperatur
     */
    void setzeTemperaturanzeige(double neueTemperatur)
    {
        temperaturanzeige.TextSetzen("" + neueTemperatur);
    }
    
    /**
     * Methode setzeTextWarnanzeige
     *
     * @param neuerText der neue Text
     */
    void setzeTextWarnanzeige(String neuerText)
    {
        warnanzeige.TextSetzen(neuerText);
    }
    
    /**
     * Methode setzeTextWarnanzeige
     *
     * @param neuerText der neue Text
     */
    void setzeTextWarnanzeigeFürDauer(String neuerText, int dauerInSekunden)
    {
        warnanzeige.TextSetzen(neuerText);
        try{Thread.sleep(dauerInSekunden*1000);}catch(Exception e){};
 
    }
    
    /**
     * Methode setzeFarbanzeige
     *
     * @param neueFarbe die Neue Farbe
     */
    void setzeFarbanzeige(String neueFarbe)
    { 
        farbanzeige.FarbeSetzen(neueFarbe);
    }

}

       
