import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.ArrayList;

/**
 * Klasse Methodenbox für Lichtsteuerung / autonomes Fahren  - Kapitel 1.3 Aufgabe 3
 * 
 * @author Peter Brichzin
 * @version 1.0
 */
public class Methodenbox
{
    private Rechteck strecke1;
    private Rechteck tunnel1;
    private Rechteck strecke2;
    private Rechteck strecke3;
    private Rechteck strecke4;
    private Rechteck tunnel2;
    private Rechteck strecke5;
    private Rechteck strecke6;
    private Rechteck markierung1;
    private Rechteck markierung2;
    private Rechteck markierung3;
    private Rechteck markierung4;
    private Auto auto;

    /** Anleitungstexte */
    Text anleitungstext1;
    Text anleitungstext2;

    /**
     * Der Konstruktor meldet den Taktgeber
     * und die Eventlistener bei der Zeichenfläche an.

     * Der Konstruktor legt die benötigten Objekte an und richtet sie ein.     
     */
    Methodenbox ()
    {
        Zeichenfenster.AktionsEmpfängerEintragen(new Zeichenfenster.AktionsEmpfaenger()
            {
                public void Ausführen ()
                {
                    TaktImpulsAusführen();
                }

                public void Taste (char taste)
                {
                    TasteGedrückt(taste);
                }

                public void SonderTaste (int taste)
                {
                    SonderTasteGedrückt(taste);
                }

                public void Geklickt (int x, int y, int anzahl)
                {
                    MausGeklickt(x, y, anzahl);
                }
            });

        //Aufbau der Strecken vo Startpunkt aus im Urzeigersinn
        strecke1 = new Rechteck();
        strecke1.PositionSetzen(50, 250);
        strecke1.GrößeSetzen(200, 50);
        strecke1.FarbeSetzen("grau");

        tunnel1 = new Rechteck();
        tunnel1.PositionSetzen(250, 250);
        tunnel1.GrößeSetzen(200, 50);
        tunnel1.FarbeSetzen("schwarz");

        strecke2 = new Rechteck();
        strecke2.PositionSetzen(450, 250);
        strecke2.GrößeSetzen(150, 50);
        strecke2.FarbeSetzen("grau");

        strecke3 = new Rechteck();
        strecke3.PositionSetzen(600, 50);
        strecke3.GrößeSetzen(50, 250);
        strecke3.FarbeSetzen("grau");

        strecke4 = new Rechteck();
        strecke4.PositionSetzen(450, 50);
        strecke4.GrößeSetzen(200, 50);
        strecke4.FarbeSetzen("grau");

        tunnel2 = new Rechteck();
        tunnel2.PositionSetzen(250, 50);
        tunnel2.GrößeSetzen(200, 50);
        tunnel2.FarbeSetzen("schwarz");

        strecke5 = new Rechteck();
        strecke5.PositionSetzen(50, 50);
        strecke5.GrößeSetzen(200, 50);
        strecke5.FarbeSetzen("grau");

        strecke6 = new Rechteck();
        strecke6.PositionSetzen(25, 50);
        strecke6.GrößeSetzen(50, 250);
        strecke6.FarbeSetzen("grau");

        markierung1 = new Rechteck();
        markierung1.PositionSetzen(592, 250);
        markierung1.GrößeSetzen(8, 50);
        markierung1.FarbeSetzen("blau");
        
        markierung2 = new Rechteck();
        markierung2.PositionSetzen(600, 102);
        markierung2.GrößeSetzen(50, 8);
        markierung2.FarbeSetzen("blau");
        
        markierung3 = new Rechteck();
        markierung3.PositionSetzen(77, 50);
        markierung3.GrößeSetzen(8, 50);
        markierung3.FarbeSetzen("blau");
        
        markierung4 = new Rechteck();
        markierung4.PositionSetzen(25, 240);
        markierung4.GrößeSetzen(50, 8);
        markierung4.FarbeSetzen("blau");

       
        auto = new Auto();
        auto.PositionSetzen(70, 275);

        anleitungstext1 = new Text("anleitungstext1");
        anleitungstext1.PositionSetzen(75, 400);
        anleitungstext1.TextSetzen("Mit Taste s Fahrt starten.");
        anleitungstext2 = new Text("anleitungstext2");
        anleitungstext2.PositionSetzen(75, 420);
        anleitungstext2.TextSetzen("Mit Taste z stoppen und zurück zur Ausgangsposition.");

    }

    /**
     * Methode LichtEinschalten wechselt zur Figurdarstellung mit Licht
     *
     */
    void LichtEinschalten()
    {
        auto.FigurMitLichtFestlegen();
    }

    /**
     * Methode LichtAusschalten wechselt zur Figurdarstellung ohne Licht
     *
     */
    void LichtAusschalten()
    {
        auto.FigurOhneLichtFestlegen();
    }

    /**
     * Methode Fahren zum Bewegen des Autos
     *
     * @param distanz, um die fortbewegt wird 
     */
    void Fahren(int distanz)
    {
        auto.Gehen(distanz);

    }

    /**
     * Methode Fahren zum Drehen des Autos
     *
     * @param winkle, um den gedreht wird 
     */
    void Drehen(int winkel)
    {
        auto.Drehen(winkel);

    }
    
    

    /**
     * Methode Berührt      
     * 
     * @param farbe Die Farbe als Zeichenkette
     * @return true, falls die Farbe berührt wird, false sonst
     */
    boolean Berührt(String farbe)
    {
        return auto.Berührt(farbe);
    }

    /**
     * Methode ZurückAufStartpositionVerschieben verschiebt das Auto auf die Startposition
     *
     */
    void AutoPositionSetzen(int xPos, int yPos)
    {
        auto.PositionSetzen(xPos, yPos);

    }
    
    /**
     * Methode warte, hält den Ablauf an
     *
     * @param Millisekunden Wartezeit in Millisekunden
     */
    void warte(int Millisekunden)
    {
        try {
            Thread.sleep(Millisekunden);
        } catch (InterruptedException e) {
            System.out.println("Thread is interrupted");
        }
    }

    /**
     * Die eigentliche Aktionsmethode des Zeitgebers.
     * <br>Muss bei Bedarf von einer Unterklasse überschrieben werden. 
     */
    void TaktImpulsAusführen ()
    {
        System.out.println ("Tick");
    }

    /**
     * Zeitgeber starten.
     */
    void Starten ()
    {
        Zeichenfenster.TaktgeberStarten();
    }

    /**
     * Zeitgeber anhalten.
     */
    void Anhalten ()
    {
        Zeichenfenster.TaktgeberStoppen();
    }

    /**
     * Ablaufgeschwindigkeit des Zeitgebers einstellen.
     * 
     * @param dauer: Angabe in Millisekunden
     */
    void TaktdauerSetzen (int dauer)
    {
        Zeichenfenster.TaktdauerSetzen(dauer);
    }

    /**
     * Die eigentliche Aktionsmethode für gedrückte Tasten.
     * <br>Muss bei Bedarf von einer Unterklasse überschrieben werden. 
     * @param taste die gedrückte Taste
     */
    void TasteGedrückt (char taste)
    {
        System. out. println ("Taste: " + taste);

    }

    /**
     * Die eigentliche Aktionsmethode für gedrückte Sondertasten.
     * <br>Muss bei Bedarf von einer Unterklasse überschrieben werden. 
     * @param taste KeyCode der gedrückten Taste
     */
    void SonderTasteGedrückt (int taste)
    {
        System. out. println ("Sondertaste: " + taste);
    }

    /**
     * Die eigentliche Aktionsmethode für einen Mausklick.
     * <br>Muss bei Bedarf von einer Unterklasse überschrieben werden. 
     * @param x x-Position des Mausklicks
     * @param y y-Position des Mausklicks
     * @param anzahl Anzahl der aufeinanderfolgenden Mausklicks
     */
    void MausGeklickt (int x, int y, int anzahl)
    {
        System. out. println ("Maus: (" + x + "|" + y + "), " + anzahl + " mal");
    }

    /**
     * Klasse für ein Auto
     */
    private class Auto extends Figur
    {
        Auto()
        {
            FigurOhneLichtFestlegen();       
            this.WinkelSetzen(0);

        }

        void FigurOhneLichtFestlegen()
        {
            EigeneFigurLöschen();
            this.FigurteilFestlegenRechteck(-50, -20, 10, 5, "grün");
            this.FigurteilFestlegenRechteck(-50, 15, 10, 5, "grün");
            this.FigurteilFestlegenRechteck(-10, -20, 10, 5, "grün");
            this.FigurteilFestlegenRechteck(-10, 15, 10, 5, "grün");
            this.FigurteilFestlegenEllipse(-50, -20, 50, 40, "rot");
            this.GrößeSetzen(80);
        }

        void FigurMitLichtFestlegen()
        {
            EigeneFigurLöschen();
            this.FigurteilFestlegenDreieck(-15, 10, 40, 23, 40, -3, "gelb");
            this.FigurteilFestlegenDreieck(-15, -10, 40, -23, 40, 3, "gelb");
            this.FigurteilFestlegenRechteck(-50, -20, 10, 5, "grün");
            this.FigurteilFestlegenRechteck(-50, 15, 10, 5, "grün");
            this.FigurteilFestlegenRechteck(-10, -20, 10, 5, "grün");
            this.FigurteilFestlegenRechteck(-10, 15, 10, 5, "grün");
            this.FigurteilFestlegenEllipse(-50, -20, 50, 40, "rot");
            this.GrößeSetzen(80);

        }

        void SonderTasteGedrückt(int taste)
        {
            switch(taste)
            {
                case 37:
                    PositionSetzen(XPositionGeben() - 10, YPositionGeben());
                    break;
                case 39:
                    PositionSetzen(XPositionGeben() + 10,YPositionGeben());
            }
        }

    }
}
